#include <stdio.h>
#include <stdlib.h>
#include <xc.h>
#include "Init.h"
#include "MLX_read.h"
//#include "MLX_Neu.h" //Muss aktiviert werden, wenn der T-Sensor eine neue Adresse bekommen soll (s.u.))
// CONFIG1
#pragma config FOSC = HS        // Oscillator Selection (HS Oscillator, High-speed crystal/resonator connected between OSC1 and OSC2 pins)
#pragma config WDTE = OFF       // Watchdog Timer Enable (WDT disabled)
#pragma config PWRTE = ON       // Power-up Timer Enable (PWRT enabled)
#pragma config MCLRE = ON       // MCLR Pin Function Select (MCLR/VPP pin function is MCLR)
#pragma config CP = OFF         // Flash Program Memory Code Protection (Program memory code protection is disabled)
#pragma config BOREN = OFF      // Brown-out Reset Enable (Brown-out Reset disabled)
#pragma config CLKOUTEN = OFF   // Clock Out Enable (CLKOUT function is disabled. I/O or oscillator function on the CLKOUT pin)
#pragma config IESO = OFF       // Internal/External Switchover (Internal/External Switchover mode is disabled)
#pragma config FCMEN = OFF      // Fail-Safe Clock Monitor Enable (Fail-Safe Clock Monitor is disabled)

// CONFIG2
#pragma config WRT = OFF        // Flash Memory Self-Write Protection (Write protection off)
#pragma config VCAPEN = OFF     // Voltage Regulator Capacitor Enable bit (VCAP pin function disabled)
#pragma config STVREN = OFF     // Stack Overflow/Underflow Reset Enable (Stack Overflow or Underflow will not cause a Reset)
#pragma config BORV = LO        // Brown-out Reset Voltage Selection (Brown-out Reset Voltage (Vbor), low trip point selected.)
#pragma config LPBOR = OFF      // Low-Power Brown Out Reset (Low-Power BOR is disabled)
#pragma config LVP = OFF        // Low-Voltage Programming Enable (High-voltage on MCLR/VPP must be used for programming)

#define _XTAL_FREQ 20000000
//LATX ist ein Register, das die Ausgabe des zugehrigen PORTX regelt.
//PORTX ist der Zustand an den Pins
//LATX kann also anders sein als PORTX
#define Status LATA4 //Bit 4 des Registers LATA(=PORTA), 0 LED ein, 1 LED aus
#define Taster RC0
#define not_Taster_am_876A Datum_R[0]
//#define vorwaerts LATD = LATD & 0b11110000 | 0b00001010 //Beim Inhalt des Registers
//LATD werden zunchst die unteren 4 Bits gelscht und dann Bit 1 und 3 gesetzt.
//An PORTD liegt also dann an Pin 22 und 24 fnf Volt an, an Pin RD7..4 liegt der
//Pegel an, der auch vorher angelegen hat
//#define stopp LATD = LATD & 0b11110000
#define vorwaerts   LATD = (LATD & 0b11110000)|0b00001010
#define rueckwaerts LATD = (LATD & 0b11110000)|0b00000101
#define rechts      LATD = (LATD & 0b11110000)|0b00000110
#define links       LATD = (LATD & 0b11110000)|0b00001001
#define stopp       LATD = (LATD & 0b11110000) 
#define bissr       LATD = (LATD & 0b11110000)|0b00000010
#define bissl       LATD = (LATD & 0b11110000)|0b00001000
//Definitionen sinnvoll ergnzen: rueckwaerts, rechts_drehen....
#define US_Trigger LATD5 //US-Trigger Pin an RD5, Pin 28
#define pwm_links   CCPR1L 
#define pwm_rechts  CCPR2L
#define Rechtsvorne  A_D_Wert[1]
#define Rechtshinten A_D_Wert[0]-10
#define linksvorne   
#define linkshinten 
#define hintenlinks 
#define hintenrechts 
#define vornerechts  A_D_Wert[2]
#define vornelinks   A_D_Wert[3]
#define schwarz      A_D_Wert[4] > 230
#define servo        RC6
#define norden       Hrichtung ==0
#define osten        Hrichtung ==1
#define sueden       Hrichtung ==2
#define west         Hrichtung ==3

//Es stehen 1024 Speicherpltze zur Verfgung
//Deklaration der Variabeln, mit Wertzuweisung
char grad_90 = 100; //90 Drehung, Anzahl der Ticks am Encoder: einstellen!!
char cm_30 = 134; //30cm fahren, Anzahl der Ticks am Encoder: einstellen!!
const char PIC_Slave = 0x14; //PIC-Slave Adresse vom 16F876A
const char PIC_Letter_1 = 0x15; //0x15 und 0x16 sind PIC-Slave Adressen von den 16F1827
const char MLX_Slave = 0x5A; //Slave Adresse von einem T-Sensor, der andere hat
        //0x5B als Adresse, wird in der MLX-I2C Funktion aufgerufen

char A_D_Wert [28]; //28 A/D-Wandler-Pins am 1519
char Channel [11] = {0, 1, 2, 3, 4, 5, 6, 7, 17, 18, 19}; //links vom Master ADKanal 0 - 7, rechts ADKanal 17 - 19
char Channel_Index;

//Deklaration der Variabeln, ohne Wertzuweisung
char I2C_Add; //aktuell zu verarbeitende I2C-Adresse
char I2C_Index_w; //Write Index, aktuell zu verarbeitendes Register/Datum-Paar
char I2C_Index_R; //Read Index, aktuell zu verarbeitendes Register/Datum-Paar
bit I2C_Write; //Ist der I2C-Bus gerade mit Schreiben beschftigt?
bit I2C_Read; //Ist der I2C-Bus gerade mit Lesen beschftigt?
char I2C_Count; //Zhler der Schritte bei der I2C-Kommunikation
char Count; //Zhler fr I2C_Index_w
char zunah = 85;
char zuweit = 75;
char wand = 50;
char Abstand_von_Wand;

char Datum_S[20]; //ans LCD zu bertragene Werte
char Datum1_an_Letter;
char Datum2_an_Letter;
bit Flag_kalibrieren;
char Register_S; //LCD Tabulatorstelle
char Datum_R[3]; //vom 16F876A[0] und 16F1827[1] u [2] gelesene Werte
char Register_R_MLX = 0x07; // in 0x07 und 0x08 stehen LO- und HI-Byte der Temperatur
int Tick; //Zhler der TMR0 berlufe im Interrupt
char m, n; //Zhler im Interrupt
char n_US; //Zhler fr US-Trigger, 40ms
char Zeit_US; //Laufzeit des US-Signals
char Abstand_US; //Abstand vom US in cm (ca. 10% ungenau)
bit Flag_LED; //Soll die LED blinken (1) oder an sein (0)

char I2C_Add; //aktuell benutzte I2C-Slave-Adresse
char Temperatur_LO_rechts; //Den Wert brauchen wir nicht unbedingt
char Temperatur_LO_links; //Den Wert brauchen wir nicht unbedingt
char Temperatur_HI_rechts; //HI-Teil der Temperatur
char Temperatur_HI_links; //HI-Teil der Temperatur
char Waerme_links = 58;
char Waerme_rechts = 58;
bit Flag_T_links = 0;
bit Flag_T_rechts = 0;
signed char Hrichtung = 0;
char feld [32][5];
char liste [32];
char standort = 0;

char Encoder; //Anzahl der Motordrehungen, Raddurchmesser 60mm -> ca. 5 Umdrehungen = 1cm
int flag_kein_temp; //geht mit encoder hoch
int Strecke; //Lnge des zu fahrenden Wegs in Motorumdrehungen
bit Flag_Strecke_erreicht; //die vorgegebene Strecke ist erreicht -> Interrupt
bit Flag_Strecke_messen; //Es wird gerade eine Strecke gemessen -> Interrupt
char Count_Bitwert;

char z; //Kann man immer mal gebrauchen

void init(void); //Chip initialisieren
void Strecke_fahren(char, char); //(Lnge, Richtung)
void Strecke_30cm(void); //sic
void links_drehen(void); //90
void rechts_drehen(void); //90
void Letter_kal(void); //Buchstabensensoren kalibrieren
void interrupt Interrupt(void); //sic
void wandlang(void);
void vorneausrichten(void);
void ecke(void);
void vornewand(void);
void schwarzabfrage(void);
void rescuelinks(void);
void rescuerechts(void);
void allesabfragen(void);
void vornewandohnealles (void);
void rechtsausrichten (void);
void Tabelleausfuellen(void);
void Werte_auf_LCD_anzeigen (void);

/*
 * Jetzt gehts los
 */
/*Hauptfunktion*/
void main(void) {
    init(); //Chip initialisieren, incl. I2C
    stopp; //Erstmal alle Motoren aus
    
//    MLX_Neu(); //Dem Temperatursensor eine neue Adresse geben
    //Dazu mssen die Zeile 7 (#include "MLX_Neu.h")  und die Zeile hier drber
    //aktiviert werden. Kurz, 1s, den Roboter einschalten und dann alles wieder
    //auskommentieren. Es darf dabei natrlich nur ein T-Sensor angeschlossen sein.
    
    //Zum Debuggen knnen Interrupts ein und aus geschaltet werden:
    TMR1IE = 0; //En/Disable TMR1-Interrupt
    IOCIE = 0; //En/Disable Interupt on Change, RB7..1/0
    TMR0IE = 1; //En/Disable TMR0 Interrupt
    SSPIE = 1; //En/Disable SSP Interrupt
    INTE = 0; //En/Disable Interrupt on RB0
    ADIE = 0; //En/Disable Interrupt on AD-Module
    //Flags zurck setzen
    I2C_Write = 0; //Ist der I2C gerade mit Schreiben beschftigt?
    I2C_Read = 0; //Ist der I2C gerade mit Lesen beschftigt?
    Flag_LED = 1; //Normales LED-Blinken
    
    Flag_Strecke_erreicht = 1;
    Flag_Strecke_messen = 0;
    
    __delay_ms(600); //Allen Sensoren Zeit lassen auf den Anfangswert einzupegeln
    GIE = 1; //En/Disable General Interrupt
    __delay_ms(400); //die ersten Werte holen (dauert natrlich nicht 400ms) 
    //testschleife
    while(1) {
        NOP();
//        vorwaerts;
//        pwm_links = 80;
//        pwm_rechts = 60; 
    }

    Letter_kal(); //Buchstabensensoren kalibrieren

/*Hier gehts los, nachdem der Taster am Master gedrckt wurde*/    

    while (1) { 
//        allesabfragen();
//        schwarzabfrage();
//        wandlang();
//        ecke();
//        vornewand();
        Werte_auf_LCD_anzeigen();
    }
}

//void rechtsausrichten(void){
//    if (Rechtsvorne > wand ){
//        if (Rechtsvorne < Rechtshinten +3){
//            while (Rechtsvorne < Rechtshinten){
//                bissr;
//                __delay_ms(5);
//                stopp;
//                __delay_ms(15);
//            }
//        }
//        else {
//            if (Rechtsvorne > Rechtshinten -3){
//            while (Rechtsvorne > Rechtshinten){
//                bissl;
//                __delay_ms(5);
//                stopp;
//                __delay_ms(15);
//            }
//            }
//        }
//    }
//}
//void allesabfragen(void){
//    rescuelinks();
//    rescuerechts();
//}
//void rescuelinks(void){
//     if (Flag_T_rechts == 1){
//         Flag_T_rechts = 0;
//        if (flag_kein_temp > 300){
//            Strecke_fahren(20,vorwaerts);
//            while(!Flag_Strecke_erreicht);
//            stopp;
//            for(char i=0; i<20; i++){
//                        servo = 1;
//                        __delay_us(1100);
//                        servo = 0;
//                        __delay_ms(20);
//                        }
//                           for(char i=0; i<6; i++){
//                               servo = 1;
//                               __delay_us(1090);
//                               servo = 0;
//                               __delay_ms(20);
//                               servo = 1;
//                               __delay_us(1120);
//                               servo = 0;
//                               __delay_ms(20);
//                               servo = 1;
//                               __delay_us(1100);
//                               servo = 0;
//                               __delay_ms(20);
//                           }
//                            for (char i=0; i<6; i++){
//                                        rechts;
//                                        __delay_ms(50);
//                                        links;
//                                        __delay_ms(50);
//                                        stopp;
//                                       }
//                for(char i=0; i<20; i++){
//                        servo = 1;
//                        __delay_us(2550);
//                        servo = 0;
//                        __delay_ms(20);
//                        }
//                           for(char i=0; i<6; i++){
//                               servo = 1;
//                               __delay_us(2540);
//                               servo = 0;
//                               __delay_ms(20);
//                               servo = 1;
//                               __delay_us(2560);
//                               servo = 0;
//                               __delay_ms(20);
//                               servo = 1;
//                               __delay_us(2550);
//                               servo = 0;
//                               __delay_ms(20);
//                           }
//                for (char i=0; i<6; i++){
//                    rechts;
//                    __delay_ms(50);
//                    links;
//                    __delay_ms(50);
//                }
//
//                 Strecke_fahren(20,rueckwaerts);
//                while(!Flag_Strecke_erreicht);
//                stopp;
//                flag_kein_temp = 0;
////                __delay_ms(1000);
//                 vorneausrichten();
//               rechtsausrichten();
//               stopp;
//            }
//        }
//    }
//void rescuerechts(void){
//    if (Flag_T_links == 1){
//        Flag_T_links = 0;
//        if (flag_kein_temp > 300){
//            Strecke_fahren(20,vorwaerts);
//            while(!Flag_Strecke_erreicht);
//            stopp;
//            for(char i=0; i<20; i++){
//                servo = 1;
//                __delay_us(1100);
//                servo = 0;
//                __delay_ms(20);
//                }
//                        for(char i=0; i<6; i++){
//                            servo = 1;
//                            __delay_us(1090);
//                            servo = 0;
//                            __delay_ms(20);
//                            servo = 1;
//                            __delay_us(1120);
//                            servo = 0;
//                            __delay_ms(20);
//                            servo = 1;
//                            __delay_us(1100);
//                            servo = 0;
//                            __delay_ms(20);
//                        }
//                        for (char i=0; i<6; i++){
//                        rechts;
//                        __delay_ms(50);
//                        links;
//                        __delay_ms(50);
//                        stopp;
//                       }
//                 for(char i=0; i<20; i++){
//                         servo = 1;
//                         __delay_us(450);
//                         servo = 0;
//                         __delay_ms(20);
//                         }
//                        for(char i=0; i<6; i++){
//                            servo = 1;
//                            __delay_us(440);
//                            servo = 0;
//                            __delay_ms(20);
//                            servo = 1;
//                            __delay_us(460);
//                            servo = 0;
//                            __delay_ms(20);
//                            servo = 1;
//                            __delay_us(450);
//                            servo = 0;
//                            __delay_ms(20);
//                        }
//              for (char i=0; i<6; i++){
//                 rechts;
//                 __delay_ms(50);
//                 links;
//                 __delay_ms(50);
//                }
//            Strecke_fahren(20,rueckwaerts);
//               while(!Flag_Strecke_erreicht);
//               stopp;
//               flag_kein_temp = 0;
////               __delay_ms(1000);
//               vorneausrichten();
//               rechtsausrichten();
//               stopp;
//        }
//    } 
//}   
//void vornewandohnealles(void){
//    if (vornerechts > 51){
//                  vorneausrichten();
//                    links_drehen();
//                    while(!Flag_Strecke_erreicht);
//                    stopp;
//                    rechtsausrichten();
//                    //__delay_ms(500);
//                }
//}
//void schwarzabfrage(void){
//    if(schwarz){
//        stopp;
//        __delay_ms(500);
//        Strecke_fahren(40,vorwaerts);
//        while (!Flag_Strecke_erreicht);
//        stopp;
//        if (schwarz){
//             Strecke_fahren(40,rueckwaerts);
//            while (!Flag_Strecke_erreicht);
//            stopp;
//            __delay_ms(500);
//            Strecke_fahren(80,rueckwaerts);
//             while(!Flag_Strecke_erreicht);
//             stopp; 
//             rechtsausrichten();
//             links_drehen();
//             while(!Flag_Strecke_erreicht);
//             stopp;
//             rechtsausrichten();
//             if (vornelinks > wand){
//                 vornewand();
//             }
//             else{
//                 Strecke_fahren(90,vorwaerts);
//                 while(!Flag_Strecke_erreicht) {
//                     allesabfragen();
//                 }
//                 rechtsausrichten();
//                 stopp;
//            }
//        }    
//    }
//}
//void vornewand(void){
//    if (vornerechts > 51){
//                  vorneausrichten();
//                    links_drehen();
//                    while(!Flag_Strecke_erreicht){
//                        allesabfragen();
//                    }
//                    stopp;
//                    rechtsausrichten();
//                    //__delay_ms(500);
//                }
//}
//void ecke(void){
//    if(Rechtsvorne < 40){
//                   Strecke_fahren(70,vorwaerts);
//                   while(!Flag_Strecke_erreicht){
//                       allesabfragen();
//                       schwarzabfrage();
//                    if(vornelinks > 51){
//                       Flag_Strecke_erreicht = 1;
//                       Flag_Strecke_messen = 0;
//                    }  
//                   }
//                   stopp;
//                   //__delay_ms(500);
//                   vorneausrichten();
//                   rechts_drehen();
//                   while(!Flag_Strecke_erreicht){
//                       allesabfragen();
//                   }
//                   stopp;
//                   rechtsausrichten();
//                   Strecke_fahren(60,vorwaerts);
//                   while(!Flag_Strecke_erreicht){
//                       allesabfragen();
//                   }
//                   stopp;
//                   //__delay_ms(500);          
//                }
//}
//void vorneausrichten(void){
//
//    if(vornelinks > wand){
//        if (vornerechts < vornelinks){
//            while (vornerechts < vornelinks){
//                bissl;
//                __delay_ms(5);
//                stopp;
//                __delay_ms(15);
//            }
//        }
//        else {
//            if (vornerechts > vornelinks -3){
//                while (vornerechts > vornelinks){
//                bissr;
//                __delay_ms(5);
//                stopp;
//                __delay_ms(15);
//                }
//            }
//        }
//        if(vornelinks > zunah +3){
//            while(vornelinks > zunah +3){
//                rueckwaerts;
//                __delay_ms(5);
//                 stopp;
//                 __delay_ms(15);
//            }
//            stopp;
//        }
//        else{
//            if(vornelinks < zuweit -3 ){
//                while(vornelinks < zuweit -3){
//                 vorwaerts;  
//                 __delay_ms(5);
//                 stopp;
//                 __delay_ms(15);
//                }
//            stopp;
//            }
//        }
//    }
//}
//void wandlang(void){   
//                if (Rechtsvorne >= zunah) { //Sensor rechts vorne zu nah an der Wand?
//                    bissl; //linke Motoren aus, rechte vorwrts
//                    __delay_ms(5); //Diesen Wert anpassen, muss zusammen mit nchstem delay 20ms ergeben
//                    vorwaerts; //Beide Motoren wieder an
//                    __delay_ms(15); //Wir produzieren uns ein einfaches PWM, delta T = 1ms
//                }
//                if (Rechtsvorne <= zuweit) { //Sensor rechts vorne zu weit weg von der Wand?
//                    bissr; //rechte Motoren aus, linke vorwrts
//                    __delay_ms(5); //leichten Bogen nach rechts fahren
//                    vorwaerts; //
//                    __delay_ms(15); //
//                }
//           
//                if (Rechtsvorne < zunah) { //NICHT zu nah an Wand
//                    if (Rechtsvorne > zuweit) { //NICHT zu weit von Wand, alsogenau in dem
//                        //Intervall in dem sich der Roboter bewegen soll
//                        if (Rechtsvorne > (Rechtshinten - 5)) { //rechtsvornenher, als hinten, Hysterese = 5, evtl. Offset
//                            bissl; //"PWM"
//                            __delay_ms(4); //Werte anpassen
//                            vorwaerts; //
//                            __delay_ms(16); //
//                        }
//                        else {
//                            if (Rechtsvorne < (Rechtshinten +5)) { //rechtshinten nher
//                                bissr; //
//                                __delay_ms(4); //
//                                vorwaerts; //
//                                __delay_ms(16); //
//                            }
//                            vorwaerts; //alles im grnen Bereich
//                            __delay_ms(20);
//                        }
//                        
//                    }
//                }
//}
//
//void Strecke_fahren(char Length, char Direction) {
//    IOCIE = 0; //Jetzt knnen wir keinen Interrupt on change gebrauche
//    /*Encoder auf Integer upgraden?************************************/
//    Encoder = 0; //Encoderzhler lschen
//    /*****************************************************************/
//    Strecke = Length; //Strecke an "Interrupt" bergeben, 6 Ticks/cm (genauer: 90 Ticks/Umdrehung)
//    Flag_Strecke_erreicht = 0; //Wir fangen ja jetzt mit der Messung erst an
//    Flag_Strecke_messen = 1; //Sag ich doch
//    IOCIE = 1; //Interrupt wieder an
//    Direction; //PORTD Bit 3 - 0 Motorsteuerung
//}
//void links_drehen(void) { //90 links drehen
//    Strecke_fahren(grad_90, links); //Anzahl der Ticks des Encoders, anpassen!
//    Hrichtung --;
//    if(Hrichtung == -1){
//        Hrichtung = 4;
//    }
//}
//void rechts_drehen(void) { //90 rechts drehen
//    Strecke_fahren(grad_90, rechts); //Anzahl der Ticks des Encoders, anpassen!
//    Hrichtung ++;
//    if(Hrichtung == 4){
//        Hrichtung = 0;
//    }
//}
//void Strecke_30cm(void) { //30cm geradeaus fahren
//    Strecke_fahren(cm_30, vorwaerts); //6 Ticks/cm (genauer: 90 Ticks/Umdrehung)
//}
/*Kalibrieren der Buchstabensensoren, falls notwendig
 Taster am 16F876A einmal drcken -> kalibrieren, nochmal drcken -> es kann los gehen*/
void Letter_kal(void) {
    Flag_kalibrieren = 1; //brauchts bisher noch nicht
    while(!Taster) { //Taster am Master. Wenn gedrckt geht die Arbeitsschleife los
        Status = 1; //LED dauernd an
        if (!not_Taster_am_876A){ //Warten auf Taster am 16F876A, ungedrckt HI
            //entprellen kann man sich sparen, weil nur alle 20ms ein neuer Wert bermittelt wird
            while (!not_Taster_am_876A); //Warten auf Taster loslassen
            Datum1_an_Letter = 255; //Befehl an Letter...
            Datum2_an_Letter = 255; //...zu kalibrieren
            //Zeit, dass sich der Letter-Baustein kalibrieren kann
            while (not_Taster_am_876A) { //Warten auf Taster
               Status = 0;; // LED dauernd aus
               //Roboter langsam am Strich vorbei fahren lassen
               vorwaerts;
               __delay_ms(5);
               stopp;
               __delay_ms(15);
               Werte_auf_LCD_anzeigen(); //definierte werte auf LCD anzeigen
            }
            while (!not_Taster_am_876A); //Warten auf Taster loslassen
            Datum2_an_Letter = 254; //Bitmuster auf LCD anzeigen, als eine Zahl zwischen 0 und 255
        }
        Werte_auf_LCD_anzeigen(); //s.o.
    }
    Datum1_an_Letter = Rechtsvorne; //Muss noch angepasst werden, wenn...
    Datum2_an_Letter = Rechtshinten; //...beide Sensoren angeschlossen sind
    Flag_kalibrieren = 0; //s.o.
}

//Definition, der Werte und der Pltze die auf dem LCD angezeigt werden sollen
//Es gibt insgesamt 20 Pltze
void Werte_auf_LCD_anzeigen (void) {
    for(char i = 0; i < 11; i++) { //die ersten 11 sind die AD-Werte 
        Datum_S[i] = A_D_Wert[Channel[i]]; //HI-Teil des AD-Registers, s. Interrupt   
    }
    Datum_S[12] = Datum_R[1]; //Wert von Letter_1-Sensor
    Datum_S[13] = Datum_R[2]; //Wert von Letter_2-Sensor
    Datum_S[14] = Datum1_an_Letter; //Es werden zwei Werte an den Letter-Sensor... 
    Datum_S[15] = Datum2_an_Letter; //...bermittelt. Abstnde zur Wand
    Datum_S[16] = Encoder; //is klar
//    Datum_S[17 = ];
    Datum_S[18] = Temperatur_HI_links; //auch
    Datum_S[19] = Temperatur_HI_rechts; //auch
}

//Interrupt
void interrupt Interrupt(void) { //sic
//    Status = 1; //Hilfreich zum debuggen
    //Der Quarz schwingt mit 20MHz, jeder Befehl braucht 4 Schwingungen
    //Alle 200ns wird ein Befehl ausgefhrt (Zyklus) = 5 MHz
    //Prescaler 1:16 -> Interrupt alle 0,816ms = 816us = 4096 Zyklen = 4096 Befehle
    if (TMR0IF) {
        //Da mind. 816us vorbei sind hat mittlerweile die AD-Wandlung stattgefunden (s.u.)
        A_D_Wert [Channel_Index] = ADRESH; //A/D Resolution Hi-Byte, fr die Auswertung im Programm
        //Analogwert initialisieren, alle 812us
        Channel_Index++; //AD-Kanal, nxter Kanal
        //nxte Zeile: n anpassen an die Anzahl der AD-Kanle
        if (Channel_Index == 11) Channel_Index = 0; //
        ADCON0 = 0b10000001 | (Channel[Channel_Index] << 2); // Bit 6-2 whlen den Channel aus
/*******Jetzt mssen mind. 5us = 25 Zyklen vergehen, bevor die Wandlung gestartet werden darf
 *******D.H, wenn ab hier was gestrichen wird muss man das testen!!!!!!!!!!!!!!!!!!!!!!!!!!*/
//
        Tick++; //Blinken der Status-LED, PIC arbeitet "korrekt"
        if(Flag_LED) { //Soll die LED blinken?
            if (Tick >= 300) { //300 * 816us ~ 245ms
                Tick = 0; //Tick wieder auf 0 setzen
                Status = !Status; //0 ein, 1 aus
            }
        }
        else { //oder soll sie dauernd an sein?
            Status = 0; //LED dauernd ein
        }
/*Zeitstruktur fr den I2C Bus:
 * zwei Daten schreiben dauert ca. 300us, ein Datum lesen ca. 250us
 * Alle 812us wird m inkrementiert
 * Alle 10ms wird n inkrementiert
 * Alle 10ms wird ein T-Wert geholt, im Wechsel links/rechts
 * Alle 20ms wird ans LCD ein Wert bertragen, 3,3ms versetzt zu T-Werte holen
 * Alle 20ms wird ein Buchstabenwert vom Sensor geholt, 6,6ms versetzt zu T-Werte holen
 * _| |___________| |___________| |__________| |__________| |___ T-Werte holen
 * _______|||_________________________|||_______________________ LCD-Werte senden
 * ________________________| |________________________| |_______ Buchstaben holen
 * Da wre noch Platz fr einige andere I2C Module
 */
        m++; //Alle 812us wird m inkrementiert
        if (m == 12) { //Temperatur von MLX holen, ca. alle 10ms
        //Das Auslesen des T-Sensors darf nicht unterbrochen werden, daher am Stck
            m = 0; //Wieder von vorne zhlen
            n_US++; //Alle 40ms US triggern
            if (n_US == 4) { //40ms um?
                n_US = 0; //Zhler wieder auf Null setzen
                US_Trigger = 1; //An entsprechendem Pin 5V anlegen
                __delay_us(10); //10us warten
                US_Trigger = 0; //Trigger-Pin wieder lschen
                TMR1 = 0; //Zeitmessung beginnen
                TMR1IF = 0; //Timer-1-Interrupt-Flag lschen, max. ca. 2m messbar
            }
            n++; //fr Hufigkeit der bertragung der Werte ans LCD
            if (n == 2) n = 0;
/**********************************************************************/ 
    //Temperatur auslesen
            MLX_read (); //Dauert ca. 500us, darf nicht unterbrochen werden
            if (Temperatur_HI_links > Waerme_links) Flag_T_links = 1;
//                if (Temperatur_LO_links > 150) Flag_T_links = 1;
//            }
            if (Temperatur_HI_rechts > Waerme_rechts) Flag_T_rechts = 1 ;
//                if (Temperatur_LO_rechts > 150) Flag_T_rechts = 1;
//            }
/**********************************************************************/ 
        }
//  Send_to_LCD
        if (m == 4) { //Zeitlich versetzt zu MLX_read() ausfhren
            if (n == 0) { //Werte an Slave (LCD) bertragen, alle 20ms im Wechsel mit T holen
                SSPADD = 4; //1MHz IC-Frequenz, 20MHz/(4*(4+1))=1MHz (PICTime)
                I2C_Count = 0; //Schrittzhler zurcksetzen
                I2C_Write = 1; //Jetzt wird geschrieben
                I2C_Read = 0; //Es wird nicht gelesen
                I2C_Add = PIC_Slave; //I2C Slave-Adresse vorbereiten
                I2C_Index_w = Count++; //Datum_S[I2C_Index_w] wird ans LCD bertragen
                Register_S = I2C_Index_w; //Stelle, an die das Datum auf dem LCD angezeigt wird
                if (Count == 20) Count = 0; //Wieder von vorne
/***********************************************************************/                
                SEN = 1; //bertragung starten, lst SSP-Interrupt aus
/***********************************************************************/
            }
        }
//  Read 16F876A, PIC am LCD        
        if (m == 4) { //Zeitlich versetzt zu MLX_read()und LCD ausfhren
            if (n == 1) { //Werte vom 16F876A holen, alle 20ms im Wechsel mit T und LCD
                SSPADD = 4; //1MHz IC-Frequenz, 20MHz/(4*(4+1))=1MHz (PICTime)
                I2C_Count = 0; //Schrittzhler zurcksetzen
                I2C_Write = 0; //Es wird nicht geschrieben
                I2C_Read = 1; //Jetzt wird gelesen
                I2C_Add = PIC_Slave; //I2C Slave-Adresse vorbereiten
                I2C_Index_R = 0; //Index von Datum_R, hier 0 fr 16F876A
/************************************************************************/
                SEN = 1; //bertragung starten, lst SSP-Interrupt aus
/************************************************************************/
            }
        } 
//  Send_to_Letter;
        if (m == 8) { //Zeitlich versetzt zu MLX_read()und LCD ausfhren
            if (n == 0) { //Werte vom Letter-Slave 0x15 holen
                SSPADD = 4; //1MHz IC-Frequenz, 20MHz/(4*(4+1))=1MHz (PICTime)
                I2C_Count = 0; //Schrittzhler zurcksetzen
                I2C_Write = 1; //Jetzt wird geschrieben
                I2C_Read = 0; //Es wird nicht gelesen
                I2C_Add = PIC_Letter_1; //I2C Slave-Adresse vorbereiten
                //Hier muss noch hin, wenn 2 Letter angeschlossen sind PIC_Letter_1 oder 2
/************************************************************************/                
                Register_S = Datum1_an_Letter; //1. Datum das an Letter bertragen wird              
                I2C_Index_w = 15;
/***********************************************************************/                
                SEN = 1; //bertragung starten, lst SSP-Interrupt aus
/***********************************************************************/
            }
        }
//  Read_from_Letter;
        if (m == 8) { //Zeitlich versetzt zu MLX_read()und LCD ausfhren
            if (n == 1) { //Werte vom Letter-Slave 0x15 holen
                SSPADD = 4; //1MHz IC-Frequenz, 20MHz/(4*(4+1))=1MHz (PICTime)
                I2C_Count = 0; //Schrittzhler zurcksetzen
                I2C_Write = 0; //Jetzt wird geschrieben
                I2C_Read = 1; //Es wird nicht gelesen
                I2C_Add = PIC_Letter_1; //I2C Slave-Adresse vorbereiten
                I2C_Index_R = 1; //Daten die vom Letter x geholt werden sollen
                //Hier muss noch hin, wenn 2 Letter angeschlossen sind Index 1 oder 2
/***********************************************************************/                
                SEN = 1; //bertragung starten, lst SSP-Interrupt aus
/***********************************************************************/
            }
        }
        TMR0IF = 0; //Schluss mit TMR0-Interrupt
//AD-Wandlung starten
        //Jetzt sollten die 5us vorbei sein (s.o.)
        //Analogwert initialisieren, alle 0,812ms
        GO_nDONE = 1; //Wandlung starten (Bit 2 von ADCON0, S. 127)
        //Die Wandlung braucht 40us, es dauert aber 812us bis der Wert beim 
        //nchsten TMR0-Interrupt ausgelesen wird.
//        Status = 0; //Zum Debuggen
    }
    //Interrupt durch I2C
    if (SSPIF) { //Hat den Interrupt das SSP-Modul ausgelst?
        SSPIF = 0; //Flag lschen, gell?
        if (I2C_Write) { //Soll geschrieben werden?
            switch (I2C_Count) { //Je nachdem welchen Wert I2C_Count hat
                //I2C_Count = 0, erster Interrupt nach SEN
                case 0:
                    SSPBUF = (I2C_Add << 1) & 0b11111110; //Slaveadresse = 20[0010100X],
                    //nach CLK<9> SSPIF = 1;            LSB=0-> Master schreibt
                    I2C_Count++; //Beim nchsten Interrupt case 1 bearbeiten
                    break; //Die Funktion switch() verlassen
                //I2C_Count = 1;
                case 1:
                    SSPBUF = Register_S; //Erstes Datum schreiben
                    I2C_Count++; //Beim nchsten Interrupt case 2 bearbeiten
                    break; //Die Funktion switch() verlassen
                //I2C_Count = 2;
                case 2:
                    SSPBUF = Datum_S[I2C_Index_w]; //Zweites Datum schreiben
                    I2C_Count++; //Beim nchsten Interrupt case 3 bearbeiten
                    break; //Die Funktion switch() verlassen
                //I2C_Count = 3;
                case 3:
                    PEN = 1; //bertragung beenden
                    I2C_Count++; //Brauchts eigentlich nicht, aber wer wei...
                    I2C_Write = 0; //Flag lschen
                    break;
                //I2C_Count > 3;
                default: //Bis hierher kommt das Programm normal nicht
                    break; //Die Funktion switch() verlassen
            }
        }
        //Es wird vom PIC 16F876A nur ein Datum gelesen
        if (I2C_Read) { //Lesen ist dran
            switch (I2C_Count) { //Je nachdem welchen Wert I2C_Count hat
                //I2C_Count = 0, erster Interrupt nach SEN
                case 0:
                    SSPBUF = (I2C_Add << 1) | 0b00000001; //LSB=1-> Master liest
                    I2C_Count++; //Beim nchsten Interrupt case 1 bearbeiten
                    break; //Die Funktion switch() verlassen
                //I2C_Count = 1;
                case 1:
                    RCEN = 1; //receive enable
                    I2C_Count++; //Beim nchsten Interrupt case 2 bearbeiten
                    break; //Die Funktion switch() verlassen
                //I2C_Count = 2;
                case 2:
                    Datum_R[I2C_Index_R] = SSPBUF; //Hier ist RCEN wieder 0
                    ACKDT = 1; //Not Acknowledge, beendet die read-Sequenz
                    ACKEN = 1; //Wert von ACKDT wird gesendet, 9. Flanke
                    I2C_Count++; //Beim nchsten Interrupt case 3 bearbeiten
                    break; //Die Funktion switch() verlassen
                    //I2C_Count = 3;
                case 3:
                    PEN = 1; //Master ist fertig
                    I2C_Count++; //Beim nchsten Interrupt default bearbeiten
                    I2C_Read = 0; //Flag lschen
                    break; //Die Funktion switch() verlassen
                    //I2C_Count >3;
                default: //Bis hierher kommt das Programm normal nicht
                    break; //Die Funktion switch() verlassen
            }
        }
//        //Nach PEN springt beim erneuten SSP-Interrupt das Programmsofort hier
//        //her, weil weder I2C_Write noch I2C_Read HI ist
    }
    
//PORTB Interrupt, Interrupt on Change
    /*********************Init() anpassen: PORTB*******************************/
    if (IOCIF) {
        //IOCIF wird gelscht, wenn alle IOCBF gelscht sind!!!
        //IOCIF = 0; geht nicht!!!
        //Encoderpin PullUp on!!! 
        if (IOCBF5) { //Hat den Interrupt PORTB,5 ausgelst?
            Encoder++; //Encoder inkrementieren
            flag_kein_temp++;
            IOCBF5 = 0; //Flag lschen
        }
        //
        if (Flag_Strecke_messen) { //Wird eine Strecke gefahren?
            if (Encoder >= Strecke) { //Ende der Strecke erreicht?
                Flag_Strecke_erreicht = 1; //sic
            }
        }
//        //Entsprechend dem Echo-Eingang IOCBFx einstellen
//        if (IOCBFx) { //Hat den Interrupt PORTB,x ausgelst?
//            IOCBFx = 0; //Flag lschen
//            if (!TMR1IF) { //TMR1 ist nicht bergelaufen? Strecke < 2m (13107us Laufzeit)
//                Zeit_US = TMR1H; //Timer 1 HI-Teil
//                Abstand_US = Zeit_US - 9; //Abstand_US ~ tats. Abstand(ca. 10% Abweichung)
//            }
//            else {
//                Abstand_US = 255; //Gemessene Strecke > 2m
//                TMR1IF = 0;
//            }
//            Datum_S[5] = Abstand_US; //Anzeige auf LCD
//        }
    }
//    Status = 0; //Hilfreich frs debuggen
}

